import type { MaybePromise, RequestEvent } from "@sveltejs/kit";
import type { ClientMetadata, UserinfoResponse, errors } from "openid-client";
import type { LuciaAdapter } from "./adapters/abstract.js";
export type Empty = Record<never, never>;
export interface Config<Session extends Record<never, never>, User extends Record<never, never>> extends ClientMetadata {
    client_secret: string;
    scope: string;
    issuer?: string;
    on?: {
        accessDenied?: (event: RequestEvent, error: errors.OPError) => never;
        login?: (event: RequestEvent, userInfo: UserinfoResponse) => never;
        logout?: (event: RequestEvent) => MaybePromise<void>;
    };
    adapter: LuciaAdapter<Session, User>;
    cookieNames?: Partial<CookieNames>;
    paths?: Partial<Paths>;
}
export type Paths = {
    home: string;
    callback: string;
    logoutCallback: string;
    login: string;
    logout: string;
};
export type CookieNames = {
    oauthState: string;
    oauthCodeVerifier: string;
};
export interface AIDCLocals {
    authPaths: Paths;
    user: import("lucia").User | null;
    session: import("lucia").Session | null;
}
